{{
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//  Sample player object using video generator as 11 bit stereo 2x oversampling dac with noise shaper
//  Uses 2 cogs (one cog = one channel)
//  Warning - extremal pll setting!!! (224 MHz).. This is the end of the Propeller...
//
//  Piotr Kardasz pik33@o2.pl
//  Plays a 512 16-bit stereo samples buffer in endless loop
//  v.0.08 alpha - 20120713
//
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
}}


  _clkmode = xtal1+pll16x
  _clkfreq = 80_000_000

  _SD_DO = 0
  _SD_CLK = 1
  _SD_DI = 2
  _SD_CS = 3
  _SD_WP = -1 ' -1 ifnot installed.
  _SD_CD = -1 ' -1 ifnot installed.

VAR

  long cog1
  long cog2

  long buf[512]
  long bufnum


obj

fat :   "kyefat_lfn"

pub demo | i

fat.FATEngineStart(_SD_DO, _SD_CLK, _SD_DI, _SD_CS, _SD_WP, _SD_CD, -1, -1, -1)
i:=fat.mountpartition(0)
start(11,10)
'buf:=sample.getbuf

repeat
  fat.openfile(string("wav.wav"),"R")
  repeat
    repeat until bufnum>1024
    i:=fat.readdata(@buf,1024)
    repeat until bufnum<1024
    i:=fat.readdata(@buf+1024,1024)
  until i<>1024

pub getbuf
return @buf

pub getbufnum
return bufnum


PUB start(left, right)

longfill(@buf,0,512)
bufptr:=@buf
stop
outputmask := |<left | |<right
sync:=cnt+240000
cog1:=1+cognew(@init, @bufnum)
waitcnt(cnt+80000)
color1:=$44444444
bufcnt:=2
cog2:=1+cognew(@init,@bufnum)



PUB stop

if cog1>0
  cogstop(cog1-1)
  cog1 := 0
if cog2>0
  cogstop(cog2-1)
  cog2 := 0


DAT
                        org     0

init                    mov     dira,outputMask
                        mov     ctra,#0
                        movi    ctra,#%0_00001_111         'pll div 1
                        mov     frqa,frqa_val
                        mov     vscl,vscl_val2              'init video generator
                        mov     vcfg,vcfg_val
                        mov     bufptr2,par
                        waitcnt sync,#0

loop                    mov     ptr,bufptr
                        add     ptr,bufcnt         'pointer to next sample
                        rdword  sample,ptr        'get left sample
                        shl     sample,#16
                        sar     sample,#16
                        add     bufcnt,#4
                        and     bufcnt,bufmask
                        mov     over,#2
                        wrlong  bufcnt,bufptr2

p2                      add     i1,sample
                        add     i2,i1
                        mov     top,i2
                        sar     top,#5
                        mov     fb,top
                        shl     fb,#5
                        sub     i1,fb
                        sub     i2,fb

                        maxs    top, MAXVAL
                        mins    top, MINVAL
                        add     top,half
                        and     top,a7ff

                        mov     t1,top
                        add     t1,#28
                        mov     t2,a1000
                        sub     t2,t1

                        add     t2,vscl_val0
                        add     t1,vscl_val0

                        mov     vscl,t1
                        waitvid zero,zero
                        mov     vscl,t2
                        waitvid color1,ffffffff

                        mov vscl,vscl_val2
                        waitvid zero,zero

                        djnz    over,#p2

                        jmp     #loop

outputmask long    0
sample     long 0
bufmask    long %0000_0000_0000_0000_0000_0111_1111_1111
ptr        long 0
bufptr     long 0
bufcnt     long 0
bufptr2    long 0
ffffffff   long $ffffffff
zero       long 0
vscl_val   long $00001020       '
vscl_val0  long $00001000
t1         long 0
t2         long 0
vcfg_val   long $200002ff
frqa_val   long $2ce95421' $29350000
vscl_val2  long $000011ba
vscl_test1 long $00001200
time2      long 0
temp       long 0
a7ff       long $7ff
a1000      long $838
half       long $400
i1         long 0
i2         long 0
top        long 0
fb         long 0
minval     long -1023
maxval     long 1023
color1     long $88888888
sync       long 0
over       long 0


                        fit     496

{{

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                  TERMS OF USE: MIT License
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
// Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation
// files (the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy,
// modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the
// Software is furnished to do so, subject to the following conditions:
//
// The above copyright notice and this permission notice shall be included in all copies or substantial portions of the
// Software.
//
// THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE
// WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR
// COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE,
// ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
}}
